Tracking bug for BGPaaSv2 implementation

Bug #1552952 reported by Nischal Sheth on 2016-03-03
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Juniper Openstack
Status tracked in Trunk
Trunk
Fix Committed
Wishlist
Nischal Sheth

Bug Description

BGPaaS was implemented via bug 1518047.

The initial implementation has a limitation that routes can only be
advertised from the bgpaas-client to the bgpaas-server. Assumption
is that the client has a static default route with the subnet default
gateway as the nexthop.

This bug tracks an enhancement to remove above limitation and allow
bidirectional exchange of routes between the client and server. The
server will advertise routes to the client with the bgp nexthop set
to the default gateway of the subnet to which the client belongs.

Config changes are tracked via bug 1563075.
UI changes are tracked via bug 1558168.

Nischal Sheth (nsheth) on 2016-03-03
Changed in juniperopenstack:
assignee: nobody → Nischal Sheth (nsheth)
Nischal Sheth (nsheth) on 2016-03-03
description: updated
Nischal Sheth (nsheth) on 2016-03-04
tags: added: bgpaas
Nischal Sheth (nsheth) wrote :

Summary of Design

- Add gateway address fields for v4 and v6 to BgpRouterParams
- ST populates these fields in the client bgp-router's properties
- CN parses and processes these fields
- CN makes the gateway address part of RibExportPolicy
- CN updates nexthops for exported routes based on RibExportPolicy

Review in progress for https://review.opencontrail.org/18189
Submitter: Nischal Sheth (<email address hidden>)

Reviewed: https://review.opencontrail.org/18189
Committed: http://github.org/Juniper/contrail-controller/commit/4ada41f32e5bf0de274e07ddd6e773eca55a836f
Submitter: Zuul
Branch: master

commit 4ada41f32e5bf0de274e07ddd6e773eca55a836f
Author: Nischal Sheth <email address hidden>
Date: Fri Mar 4 15:08:31 2016 -0800

BGPaaSv2: Parse and process gateway address for bgp peer

Change-Id: Id4e7e2b26ac1650f0426680af233f924ca630668
Partial-Bug: 1552952

Review in progress for https://review.opencontrail.org/18311
Submitter: Nischal Sheth (<email address hidden>)

Reviewed: https://review.opencontrail.org/18311
Committed: http://github.org/Juniper/contrail-controller/commit/b6cb6c0575d46d0877cf4e944d107ee45b3eeb04
Submitter: Zuul
Branch: master

commit b6cb6c0575d46d0877cf4e944d107ee45b3eeb04
Author: Nischal Sheth <email address hidden>
Date: Mon Mar 7 15:22:46 2016 -0800

BGPaaSv2: Use gateway address in RibExportPolicy

Change-Id: Idd14d97d088b51206646e9a9d8578df14ac5497e
Partial-Bug: 1552952

Review in progress for https://review.opencontrail.org/18357
Submitter: Nischal Sheth (<email address hidden>)

Reviewed: https://review.opencontrail.org/18357
Committed: http://github.org/Juniper/contrail-controller/commit/feeb4238fcad9406f22e611441381d4163f4b471
Submitter: Zuul
Branch: master

commit feeb4238fcad9406f22e611441381d4163f4b471
Author: Nischal Sheth <email address hidden>
Date: Fri Mar 11 11:45:04 2016 -0800

BGPaaSv2: Implement AS override functionality

Consider 2 bgpaas-clients in the same VN that are configured with the
same ASN. Routes sent by one client will not be advertised to the other
client by default since CN implements a sender side AS loop check.

CN needs to implement equivalent of JUNOS as-override knob in order to
work around this issue. RibOut AS is replaced by CN AS in the AS Path.

Pending items:

- Schema and config parsing changes to enable AS override
- Do not advertise routes back to peer even if as override is enabled

Change-Id: I963a8cb6cdbdf4ed27cd18726371e9a8bb19dd39
Partial-Bug: 1552952

Review in progress for https://review.opencontrail.org/18473
Submitter: Nischal Sheth (<email address hidden>)

Review in progress for https://review.opencontrail.org/18506
Submitter: Nischal Sheth (<email address hidden>)

Reviewed: https://review.opencontrail.org/18473
Committed: http://github.org/Juniper/contrail-controller/commit/abfda24015ecb8e5148913c3d5516612885d990a
Submitter: Zuul
Branch: master

commit abfda24015ecb8e5148913c3d5516612885d990a
Author: Nischal Sheth <email address hidden>
Date: Mon Mar 14 09:56:32 2016 -0700

BGPaaSv2: Further progress on AS override implementation

Highlights:

- Schema and config parsing changes to enable AS override
- Implement split horizon check within an eBGP RibOut
- Strip non-transitive attributes when sending routes to eBGP peers
- Tweak resolver to retain IPeer from original BgpPath so that split
horizon check can work for resolved paths
- Make sure that resolved paths don't get deleted prematurely
- Add logic to prevent BgpLifetimeManager from deleting objects when
any resolver tasks are on the wait queue

Change-Id: I2872faf1d382192ea401f1948d842a59bfa0a4a8
Partial-Bug: 1552952

Reviewed: https://review.opencontrail.org/18506
Committed: http://github.org/Juniper/contrail-controller/commit/d3df539bcdc840debf2cec8e71ef43d9918a6627
Submitter: Zuul
Branch: master

commit d3df539bcdc840debf2cec8e71ef43d9918a6627
Author: Nischal Sheth <email address hidden>
Date: Wed Mar 16 17:12:13 2016 -0700

BGPaaSv2: Schema change to suppress route advertisement

Change-Id: I25c6bac0a3c5c6dc1d94084734a85e53de76904c
Partial-Bug: 1552952

Nischal Sheth (nsheth) on 2016-03-28
tags: removed: config
Nischal Sheth (nsheth) on 2016-03-28
description: updated
Nischal Sheth (nsheth) wrote :

Marking as Fix Committed.
New bugs will be opened for any discovered issues.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers